/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.DepartemenDao;
import com.portofolio.dto.DepartemenDto;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.vo.DepartemenId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class DepartemenService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private DepartemenDao departemenDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(DepartemenDto departemenDto) {
		result.clear();
		DepartemenId id = new DepartemenId();
		String kdDepartemen =getIdTerahir(Departemen.class.getSimpleName(), 2);
		id.setKdDepartemen(kdDepartemen);
		id.setKdProfile(getKdProfile());
		Departemen departemen = CommonUtil.findOne(departemenDao, id);
		if (CommonUtil.isNullOrEmpty(departemen)) {
			departemen = new Departemen();
			BeanUtils.copyProperties(departemenDto, departemen);
			departemen.setNoRec(generateUuid32());
			departemen.setVersion(1);
			departemen.setId(id);
			departemen = departemenDao.save(departemen);
			result.put("departemen", departemen);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("departemen.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(DepartemenDto departemenDto, String kdDepartemen, Integer version) {
		result.clear();
		DepartemenId id = new DepartemenId();
		id.setKdDepartemen(kdDepartemen);
		id.setKdProfile(getKdProfile());
		Departemen departemen = CommonUtil.findOne(departemenDao, id);
		if (CommonUtil.isNotNullOrEmpty(departemen)) {
			if (version < departemen.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(departemenDto, departemen);
			departemen.setVersion(version);
			departemen = departemenDao.save(departemen);
			result.put("departemen", departemen);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaDepartemen,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaDepartemen)) {
			pageRes = departemenDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = departemenDao.findAllList(getKdProfile(), namaDepartemen, statusEnabled, pageReq);
		}
		result.put("departemen", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdDepartemen(String kdDepartemen) {
		result.clear();
		result.put("departemen", departemenDao.findByKdDepartemen(getKdProfile(), kdDepartemen, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdDepartemen, Integer version) {
		result.clear();
		DepartemenId id = new DepartemenId();
		id.setKdDepartemen(kdDepartemen);
		id.setKdProfile(getKdProfile());
		Departemen departemen = CommonUtil.findOne(departemenDao, id);
		if (CommonUtil.isNotNullOrEmpty(departemen)) {
			if (version < departemen.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			departemen.setStatusEnabled(false);
			departemen.setVersion(version);
			departemen = departemenDao.save(departemen);
			result.put("departemen", departemen);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
